<CsoundSynthesizer>
<CsOptions>
-+Q -+e -+Y -P99 -d -m0 -+O

</CsOptions>
<CsInstruments>
#define SETVER		#"Tropes_12 Ver. 1 [MIDI Sequencer]"#
#define WEB		#"www.alessandro-petrolati.com"#
#define BUGS		#"Bugs/comments report: http://www.alessandro-petrolati.com"#
#define CSOUNDAV	#"CsoundAV 0.043 A real-time oriented version of Csound Copyright  1997-2000 Gabriel Maldonado http://csounds.com/maldonado"#
#define PROJECT		#"BROWSE_FILE"#

	sr	=	32000	;31.25	kBaud (MIDI streem)
	kr	=	32000


#define SplitDownMin #0# 
#define SplitDownMax #87#
#define SplitDownDef #60#

#define SplitUpMin #0#
#define SplitUpMax #87# 
#define SplitUpDef #72# 

#define NumberEventsBegMin #0.5#
#define NumberEventsBegMax #50#
#define NumberEventsBegDef #5#

#define NumberEventsEndMin #0.5#
#define NumberEventsEndMax #50#
#define NumberEventsEndDef #16#


#define DurationEventsBegMin #0#
#define DurationEventsBegMax #5#
#define DurationEventsBegDef #.3#

#define DurationEventsEndMin #0#
#define DurationEventsEndMax #5#
#define DurationEventsEndDef #.3#

#define AmpEventsBegMin #0#
#define AmpEventsBegMax #127#
#define AmpEventsBegDef #50#

#define AmpEventsEndMin #0#
#define AmpEventsEndMax #127#
#define AmpEventsEndDef #50#

#define WidthSerieMin #0#
#define WidthSerieMax #1#
#define WidthSerieDef #.5#

#define AccentSerieMin #0#
#define AccentSerieMax #1#
#define AccentSerieDef #0.08#

#define Curva_1Min #-10#
#define Curva_1Max #10#
#define Curva_1Def #0#

#define Curva_2Min #-10#
#define Curva_2Max #10#
#define Curva_2Def #0#

#define Curva_3Min #-10#
#define Curva_3Max #10#
#define Curva_3Def #0#


strset 48, "C_3"
strset 24, "C_1"
strset 26, "D_1"
strset 28, "E_1"
strset 31, "G_1"
strset 33, "A_1"
strset 23, "B_0"
strset 35, "B_1"
strset 21, "A_0"
strset 27, "D#_1"
strset 54, "F#_3"
strset 34, "A#_1"
strset 30, "F#_1"
strset 25, "C#_1"
strset 29, "F_1"
strset 32, "G#_1"
strset 41, "F_2"
strset 43, "G_2"
strset 68, "G#_4"
strset 38, "D_2"
strset 22, "A#_0"
strset 44, "G#_2"
strset 40, "E_2"
strset 56, "G#_3"
strset 37, "C#_2"
strset 45, "A_2"
strset 42, "F#_2"
strset 46, "A#_2"
strset 53, "F_3"
strset 51, "D#_3"
strset 58, "A#_3"
strset 52, "E_3"
strset 36, "C_2"
strset 49, "C#_3"
strset 77, "F_5"
strset 55, "G_3"
strset 39, "D#_2"
strset 57, "A_3"
strset 66, "F#_4"
strset 90, "F#_6"
strset 86, "D_6"
strset 99, "D#_7"
strset 107, "B_7"
strset 50, "D_3"
strset 59, "B_3"
strset 62, "D_4"
strset 47, "B_2"
strset 60, "C_4"
strset 101, "F_7"
strset 70, "A#_4"
strset 81, "A_5"
strset 103, "G_7"
strset 67, "G_4"
strset 63, "D#_4"
strset 72, "C_5"
strset 69, "A_4"
strset 73, "C#_5"
strset 76, "E_5"
strset 104, "G#_7"
strset 78, "F#_5"
strset 74, "D_5"
strset 61, "C#_4"
strset 64, "E_4"
strset 65, "F_4"
strset 71, "B_4"
strset 79, "G_5"
strset 84, "C_6"
strset 75, "D#_5"
strset 106, "A#_7"
strset 80, "G#_5"
strset 83, "B_5"
strset 82, "A#_5"
strset 85, "C#_6"
strset 88, "E_6"
strset 105, "A_7"
strset 91, "G_6"
strset 97, "C#_7"
strset 89, "F_6"
strset 92, "G#_6"
strset 94, "A#_6"
strset 100, "E_7"
strset 87, "D#_6"
strset 93, "A_6"
strset 95, "B_6"
strset 96, "C_7"
strset 108, "C_8"
strset 98, "D_7"
strset 102, "F#_7"

gifont		init		1
gispace		init		256
giNserie	init		0
giGradiSerie	init		12

#define DEFAULT # $SplitDownDef,$SplitUpDef,$NumberEventsBegDef,$NumberEventsEndDef,$DurationEventsBegDef,$DurationEventsEndDef,$AmpEventsBegDef,$AmpEventsEndDef,$WidthSerieDef,$AccentSerieDef, $Curva_1Def,$Curva_2Def,$Curva_3Def#
gisnap0		ftgen	200,	0,	gispace,	-2,	$DEFAULT
gisnap1		ftgen	201,	0,	gispace,	-2,	$DEFAULT
gisnap2		ftgen	202,	0,	gispace,	-2,	$DEFAULT
gisnap3		ftgen	203,	0,	gispace,	-2,	$DEFAULT
gisnap4		ftgen	204,	0,	gispace,	-2,	$DEFAULT
gisnap5		ftgen	205,	0,	gispace,	-2,	$DEFAULT
gisnap6		ftgen	206,	0,	gispace,	-2,	$DEFAULT
gisnap7		ftgen	207,	0,	gispace,	-2,	$DEFAULT
gisnap8		ftgen	208,	0,	gispace,	-2,	$DEFAULT
gisnap9		ftgen	209,	0,	gispace,	-2,	$DEFAULT
gisnap10	ftgen	210,	0,	gispace,	-2,	$DEFAULT
gisnap11	ftgen	211,	0,	gispace,	-2,	$DEFAULT
gisnap12	ftgen	212,	0,	gispace,	-2,	$DEFAULT
gisnap13	ftgen	213,	0,	gispace,	-2,	$DEFAULT
gisnap14	ftgen	214,	0,	gispace,	-2,	$DEFAULT
gisnap15	ftgen	215,	0,	gispace,	-2,	$DEFAULT

iKeybX 		init 10
iKeybY 		init 40+30
iRiscWidth	init 1
iRiscHeight	init 1

iw 	init iRiscWidth*15
ih 	init iRiscHeight*20
ix 	init iKeybX  
iwb	init (iw/2)+3
ihb	init ih*2  
ixb	init iwb+ix
iyb	init iKeybY
iy	init ihb+iyb  

gk5 init 0
gk8 init 0

#define ESTREMI #
ispace		FLbox	" ",	1,gifont,11,1,ih+ihb,ix+(iw*51)-1,iyb
		FLsetColor 55,55,55,ispace
kA0, gihA0	FLbutton " ",1,	0,	11,	iw, 	ih,	ix,	iy, 	+105,100,0,$DurationEventsBegMax,21,gk8,gk5
		FLsetColor 255,255,255,gihA0
		FLsetBox	4,gihA0
kBb, gihBb	FLbutton " ",1,	0,	1,	iwb, 	ihb,	ixb,	iyb, 	+105,100,0,$DurationEventsBegMax,22,gk8,gk5
		FLsetColor 0,0,0,gihBb
		FLsetBox	4,gihBb
kB, gihB		FLbutton " ",1,	0,	1,	iw, 	ih,	ix+iw,	iy, 	+105,100,0,$DurationEventsBegMax,23,gk8,gk5
		FLsetColor 255,255,255,gihB
		FLsetBox	4,gihB
kC8, ihC8	FLbutton " ",1,	0,	1,	iw, 	ih+ihb,	ix+(iw*51),	iyb, 	+105,100,0,$DurationEventsBegMax,108,gk8,gk5
		FLsetColor 255,255,255,ihC8
		FLsetBox	4,ihC8
#

#define REPLACE(a'b') #
ispace		FLbox	" ",	1,gifont,11,1,ih+ihb,$a+ix-1,iyb
		FLsetColor 55,55,55,ispace
ispace1		FLbox	" ",	1,gifont,11,1,ih+ihb,$a+(ix+iw*3)-1,iyb
		FLsetColor 55,55,55,ispace1
kC, ihC		FLbutton " ",1,	0,	1,	iw, 	ih,	$a+ix,		iy, 	+105,100,0,$DurationEventsBegMax,$b+24,gk8,gk5
		FLsetColor 255,255,255,ihC
		FLsetBox	4,ihC
kDb, ihDb	FLbutton " ",1,	0,	1,	iwb, 	ihb,	$a+ixb,		iyb,	+105,100,0,$DurationEventsBegMax,$b+25,gk8,gk5
		FLsetColor 0,0,0,ihDb
		FLsetBox	4,ihDb
kD, ihD		FLbutton " ",1,	0,	1,	iw, 	ih,	$a+ix+iw,	iy, 	+105,100,0,$DurationEventsBegMax,$b+26,gk8,gk5
		FLsetColor 255,255,255,ihD
		FLsetBox	4,ihD
kEb, ihEb	FLbutton " ",1,	0,	1,	iwb, 	ihb,	$a+(ixb+iw),	iyb, 	+105,100,0,$DurationEventsBegMax,$b+27,gk8,gk5
		FLsetColor 0,0,0,ihEb
		FLsetBox	4,ihEb
kE, ihE		FLbutton " ",1,	0,	1,	iw, 	ih,	$a+(ix+(iw*2)),	iy, 	+105,100,0,$DurationEventsBegMax,$b+28,gk8,gk5
		FLsetColor 255,255,255,ihE
		FLsetBox	4,ihE
kF, ihF		FLbutton " ",1,	0,	1,	iw, 	ih,	$a+(ix+(iw*3)),	iy, 	+105,100,0,$DurationEventsBegMax,$b+29,gk8,gk5
		FLsetColor 255,255,255,ihF
		FLsetBox	4,ihF
kGb, ihGb	FLbutton " ",1,	0,	1,	iwb, 	ihb,	$a+(ixb+(iw*3)),iyb, 	+105,100,0,$DurationEventsBegMax,$b+30,gk8,gk5
		FLsetColor 0,0,0,ihGb
		FLsetBox	4,ihGb
kG, ihG		FLbutton " ",1,	0,	1,	iw, 	ih,	$a+(ix+(iw*4)),	iy, 	+105,100,0,$DurationEventsBegMax,$b+31,gk8,gk5
		FLsetColor 255,255,255,ihG
		FLsetBox	4,ihG
kAb, ihAb	FLbutton " ",1,	0,	1,	iwb, 	ihb,	$a+(ixb+(iw*4)),iyb, 	+105,100,0,$DurationEventsBegMax,$b+32,gk8,gk5
		FLsetColor 0,0,0,ihAb
		FLsetBox	4,ihAb
kA, ihA		FLbutton " ",1,	0,	1,	iw, 	ih,	$a+(ix+(iw*5)),	iy, 	+105,100,0,$DurationEventsBegMax,$b+33,gk8,gk5
		FLsetColor 255,255,255,ihA
		FLsetBox	4,ihA
kBb, ihBb	FLbutton " ",1,	0,	1,	iwb, 	ihb,	$a+(ixb+(iw*5)),iyb, 	+105,100,0,$DurationEventsBegMax,$b+34,gk8,gk5
		FLsetColor 0,0,0,ihBb
		FLsetBox	4,ihBb 
kB, ihB		FLbutton " ",1,	0,	1,	iw, 	ih,	$a+(ix+(iw*6)),	iy, 	+105,100,0,$DurationEventsBegMax,$b+35,gk8,gk5
		FLsetColor 255,255,255,ihB
		FLsetBox	4,ihB
#

#define	KEYBOARD # 
iCornice	FLbox	" ",	8,gifont,14,810,102,-5,49
iplacche	FLbox	" ",	1,gifont,11,iw*52,ihb,ix,iyb
		FLsetColor 255,255,255,iplacche	

$ESTREMI			;A0,Bb0,B0 And C8
$REPLACE((iw*2)+0'0')		;oct 1 C1 B1
$REPLACE((iw*2)+iw*7'12')	;oct 2 C2 B2
$REPLACE((iw*2)+iw*14'24')	;oct 3 C3 B3
$REPLACE((iw*2)+iw*21'36')	;oct 4 C4 B4
$REPLACE((iw*2)+iw*28'48')	;oct 5 C5 B5
$REPLACE((iw*2)+iw*35'60')	;oct 6 C6 B6
$REPLACE((iw*2)+iw*42'72')	;oct 2 C7 B7
#


	FLpanel	$SETVER,800,600, 100,100,7
	FLlabel 11, gifont, 0, 5, 5, 5
	FLtabs  800,600, -5,-10		
	FLgroup "Main panel",800, 600,0,25,0
inull1	FLbox	" ", 6, gifont, 12, 800,600, 0,0
	FLsetBox 0,	inull1		
ikeyb	FLbox	"Keyboard Split",	1,gifont,16,810,1,-5,25
		FLsetTextColor 128,0,0,ikeyb
		FLsetAlign	2,ikeyb
	
	$KEYBOARD

ginoteUp	FLbox	" ",	1,gifont,14,0,0,0,0
		FLsetTextColor 128,0,0,ginoteUp

ginoteDown	FLbox	" ",	1,gifont,14,0,0,0,0
		FLsetTextColor 128,0,0,ginoteDown
gk1,ginit1	FLslider	"@+52>",	$SplitDownMin,	$SplitDownMax,	0,	3,	-1,		iw*51, 	20,	iKeybX+(iw/2),	iKeybY-20
		FLsetVal_i	$SplitDownDef,ginit1
		FLsetBox	12,ginit1
		FLsetAlign	1,ginit1
		FLsetTextColor 0,0,128,ginit1
gk2,ginit2	FLslider	"@+52<",		$SplitUpMin,	$SplitUpMax, 	0,	3,	-1,	iw*51, 	20,	iKeybX+(iw/2),	iKeybY+ihb+ih
		FLsetVal_i	$SplitUpDef,ginit2
		FLsetBox	12,ginit2
		FLsetAlign	1,ginit2
		FLsetTextColor 0,0,128,ginit2

gk3,ginit3	FLslider	"Beginning events per second", $NumberEventsBegMin,	$NumberEventsBegMax, 	0,	15,	-1,	380, 	20,	10,	150+10+30
		FLsetVal_i	$NumberEventsBegDef,ginit3
		FLsetBox	1,ginit3
		FLsetAlign	6,ginit3

gk4,ginit4	FLslider	"Ending events per second", $NumberEventsEndMin,	$NumberEventsEndMax,	0,	15,	-1,	380, 	20,	410,	150+10+30
		FLsetVal_i	$NumberEventsEndDef,ginit4
		FLsetBox	1,ginit4
		FLsetAlign	6,ginit4

gk5,ginit5	FLslider	"Beginning events duration (sec.)",$DurationEventsBegMin,	$DurationEventsBegMax, 	0,	15,	-1,	380, 	20,	10,	250+5+30
		FLsetVal_i	$DurationEventsBegDef,ginit5
		FLsetBox	1,ginit5
		FLsetAlign	6,ginit5

gk6,ginit6	FLslider	"Ending events duration (sec.)", $DurationEventsEndMin,	$DurationEventsEndMax, 	0,	15,	-1,	380, 	20,	410,	200+50+5+30
		FLsetVal_i	$DurationEventsEndDef,ginit6
		FLsetBox	1,ginit6
		FLsetAlign	6,ginit6

gk8,ginit8	FLslider	"Beginning events amplitude", $AmpEventsBegMin,	$AmpEventsBegMax,	0,	15,	-1,	380, 	20,	10,	250+100+5+30
		FLsetVal_i	$AmpEventsBegDef,ginit8
		FLsetBox	1,ginit8
		FLsetAlign	6,ginit8

gk9,	ginit9	FLslider	"Ending events amplitude", $AmpEventsEndMin,	$AmpEventsEndMax, 	0,	15,	-1,	380, 	20,	410,	250+100+5+30
		FLsetVal_i	$AmpEventsEndDef,ginit9
		FLsetBox	1,ginit9
		FLsetAlign	6,ginit9

gk7,ginit7	FLslider	"Width of the aleatory mask", $WidthSerieMin,	$WidthSerieMax, 	0,	15,	-1,	380+100, 	20,	10,	  280+50+60+70+30+15
		FLsetVal_i	$WidthSerieDef,ginit7
		FLsetBox	1,ginit7
		FLsetAlign	6,ginit7
		FLsetTextColor 128,0,0,ginit7
		FLsetColor2 128,0,0,ginit7
	
gk10,	ginit10	FLslider	"Random accents", $AccentSerieMin,	$AccentSerieMax, 	0,	15,	-1,	380+100, 	20,	10,	280+60+80+20+20
		FLsetVal_i	$AccentSerieDef,ginit10
		FLsetBox	1,ginit10
		FLsetAlign	6,ginit10


gkurva1,gicurva1	FLslider	"Interpolation curve", $Curva_1Min,	$Curva_1Max, 	0,	5,	-1,	780 ,10,	10,	185+10+30		
			FLsetBox	1,gicurva1
			FLsetVal_i	$Curva_1Def,gicurva1
			FLsetColor2	128,0,0,gicurva1
gkurva2,gicurva2	FLslider	"Interpolation curve", $Curva_2Min,	$Curva_2Max, 	0,	5,	-1,	780,10,		10,	285+5+30
			FLsetBox	0,gicurva2
			FLsetVal_i	$Curva_2Def,gicurva2
			FLsetColor2	128,0,0,gicurva2
gkurva3,gicurva3	FLslider	"Interpolation curve", $Curva_3Min,	$Curva_3Max, 	0,	5,	-1,	780,10,		10,	385+5+30
			FLsetBox	0,gicurva3
			FLsetColor2	128,0,0,gicurva3
			FLsetVal_i	$Curva_3Def,gicurva3

iConvex1	FLbox	"Convex",	8,gifont,11,61,4,0,175+10+30
iLine1		FLbox	"Linear",	8,gifont,11,61,4,370,175+10+30
iConcave1	FLbox	"Concave",	8,gifont,11,61,4,735,175+10+30
		FLsetBox	1, iConvex1
		FLsetBox	1, iLine1
		FLsetBox	1, iConcave1
		FLsetTextColor	128,0,0, iConvex1
		FLsetTextColor	128,0,0, iLine1
		FLsetTextColor	128,0,0, iConcave1
iConvex2	FLbox	"Convex",	8,gifont,11,61,4,0,275+5+30
iLine2		FLbox	"Linear",	8,gifont,11,61,4,370,275+5+30
iConcave2	FLbox	"Concave",	8,gifont,11,61,4,735,275+5+30
		FLsetBox	1, iConvex2
		FLsetBox	1, iLine2
		FLsetBox	1, iConcave2
		FLsetTextColor	128,0,0, iConvex2
		FLsetTextColor	128,0,0, iLine2
		FLsetTextColor	128,0,0, iConcave2
iConvex3	FLbox	"Convex",	8,gifont,11,61,4,0,375+5+30
iLine3		FLbox	"Linear",	8,gifont,11,61,4,370,375+5+30
iConcave3	FLbox	"Concave",	8,gifont,11,61,4,735,375+5+30
		FLsetBox	1, iConvex3
		FLsetBox	1, iLine3
		FLsetBox	1, iConcave3
		FLsetTextColor	128,0,0, iConvex3
		FLsetTextColor	128,0,0, iLine3
		FLsetTextColor	128,0,0, iConcave3

FLgroup_end

	FLgroup "User",800, 600,0,25,0
inull1	FLbox	" ", 6, gifont, 12, 800,600, 0,0
	$KEYBOARD
iuser	FLbox	"Customizable MIDI controllers",	1,gifont,16,810,1,-5,25
		FLsetTextColor 128,0,0,iuser
		FLsetAlign	2,iuser


FLscroll	445+50, 350,10,155
inull9	FLbox	" ", 1, gifont, 12, 0,0, 100,155

gkCc0,ginitCc	FLslider	"Cc0 [Bank Select MSB]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc1,ginitCc	FLslider	"Cc1 [Modulation]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+50
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc2,ginitCc	FLslider	"Cc2 [Breath Controller]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+100
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc3,ginitCc	FLslider	"Cc3 [Undefined]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+150
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc4,ginitCc	FLslider	"Cc4 [Foot Controller]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+200
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc5,ginitCc	FLslider	"Cc5 [Portamento Time]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+250
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc6,ginitCc	FLslider	"Cc6 [Data Entry MSB]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+300
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc7,ginitCc	FLslider	"Cc7 [Volume]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+350
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc8,ginitCc	FLslider	"Cc8 [Undefined]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+400
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc9,ginitCc	FLslider	"Cc9 [Undefined]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+450
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc10,ginitCc	FLslider	"Cc10 [Pan]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+500
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc11,ginitCc	FLslider	"Cc11 [Espression]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+550
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc12,ginitCc	FLslider	"Cc12 [Undefined]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+600
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc13,ginitCc	FLslider	"Cc13 [Undefined]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+650
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc14,ginitCc	FLslider	"Cc14 [Undefined]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+700
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc
gkCc15,ginitCc	FLslider	"Cc15 [Undefined]", 0,	127, 	0,	15,	-1,	460, 	20,	10,	185+750
		FLsetBox	1,ginitCc
		FLsetVal_i	0,ginitCc
		FLsetColor2	128,1280,0,ginitCc
		FLsetAlign 	7,ginitCc

FLscroll_end

inull19	FLbox	"Send MIDI message", 6, gifont, 12, 257,165, 535-30+25,	175
	FLsetAlign 6,inull19

inull20	FLbox	"Active sliders", 6, gifont, 12, 257,95, 535-30+25,	180+185
	FLsetAlign 6,inull20

gkSb, gihSb	FLcount "Status Byte",0,255,1,  16,1,	120,	30,	595,	200,	-105
		FLsetVal_i 128,gihSb
		FLsetBox 4, gihSb
		FLsetAlign 2,gihSb
gkD1, gihD1	FLcount "Data Byte_1" ,0,127,1,  16,1,	110,	30,	535-30+35,	250,-105
		FLsetVal_i 0,gihD1
		FLsetBox 4, gihD1
		FLsetAlign 	6,gihD1
gkD2, gihD2	FLcount "Data Byte_2" ,0,127,1,  16,1,	110,	30,	672-30+25,	250,	-105
		FLsetVal_i 64,gihD2
		FLsetBox 4, gihD2
		FLsetAlign 	7,gihD2

gksend,ihsend	FLbutton	"Send @returnarrow", 	0,	1,	1,	110,	22,	535-30+35,	300,  	+105,8,	0,	4/kr,gkSb,gkD1,gkD2
		FLsetBox	4,ihsend
		FLsetTextSize	16,ihsend
kpanic1,ihpanic	FLbutton	"!", 	0,	1,	1,	110,	22,	672-30+25,	300,  	+105,9, 0,5 ;8,	0,		4/kr,176,123,0
		FLsetBox	4,ihpanic
		FLsetTextSize	18,ihpanic
		FLsetTextColor 128,0,0,ihpanic
gkMap1,giMap1	FLslider	"Data_1", 0,	127, 	0,	5,	-1,	245, 	20,	535,	385
		FLsetBox	6,giMap1
		FLsetVal_i	0,giMap1
		FLsetColor2	128,1280,0,giMap1
		FLsetAlign 	6,giMap1

gkMap2,giMap2	FLslider	"Data_2", 0,	127, 	0,	5,	-1,	245, 	20,	535,430
		FLsetBox	6,giMap2
		FLsetVal_i	64,giMap2
		FLsetColor2	128,1280,0,giMap2
		FLsetAlign 	7,giMap2



	FLsetBox 0,	inull1
	FLgroup_end

	FLgroup "About",800, 600,0,25,0
inull1	FLbox	" ", 6, gifont, 12, 800,600, 0,0
	FLsetBox 0,	inull1

inull3	FLbox	$SETVER, 6, gifont, 20, 440,65,40+100,90
inull4	FLbox	$WEB, 6, gifont, 18, 440,40,65+100,150
inull5	FLbox	$BUGS, 6, gifont, 16, 440,40,65+100,235
inull6	FLbox	$CSOUNDAV, 6, gifont, 16, 440,40+100,65+100,300
	FLsetBox 0,	inull3
	FLsetBox 0,	inull4
	FLsetBox 0,	inull5
	FLsetBox 0,	inull6
	FLsetTextColor 128,0,0,inull3 
	FLsetTextColor 0,0,128,inull4
	FLsetTextColor 0,0,64,inull5

	FLgroup_end
	FLtabs_end


gkplay, ihST	FLbutton "@>",1,	0,	1,	40,	25,	10,	560, 	+105,1,0, 3600
		FLsetTextColor  0, 0, 128,  ihST
		FLsetTextSize	14, ihST
		FLsetTextType   5, ihST
		FLsetBox	4,ihST

gkDirez,ihDir	FLbutton	"@<-",	0,	1,	2,	40,	25,	50,	560,  	-105,	101,	0,	0
		FLsetTextColor  0, 64, 64,  ihDir
		FLsetBox	4,ihDir
		FLsetVal_i	1,ihDir

kpanic2,ihpanic	FLbutton	"!", 	0,	1,	1,	40,	25,	90,	560,  	+105,9, 0,5
		FLsetBox	4,ihpanic
		FLsetTextSize	18,ihpanic
		FLsetTextColor 128,0,0,ihpanic

gkexit,	iex		FLbutton "X",		1,	0,	1,	40,	25,	130,	560,	+105,	110,	0,	3600
			FLsetFont	2,iex
			FLsetTextSize	12,iex
			FLsetBox 4,	iex


/*	Counter		*/

giPRINTgradi	FLvalue	"Note of serie", 	70,	22,	320+40,	560
		FLsetBox 1,giPRINTgradi
		FLsetAlign 6,giPRINTgradi
		FLhide giPRINTgradi
giPRINTserie	FLvalue	"Executed series", 	70,	22,	420+20,	560
		FLsetBox 1,giPRINTserie
		FLsetAlign 6,giPRINTserie
		FLhide giPRINTserie

/*	Snapshots	*/
gksave,ihSV	FLbutton	"Store snapshot", 	3,	0,	1,	120,	22,	535-30+25,	410+110,  	+105,	101,	0,	0
gkload,gihload	FLbutton	"Load snapshot", 	1,	0,	1,	120,	22,	672-30+25,	410+110,  	+105,	102,	0,	0
gkreset,ihRA	FLbutton	"Reset default", 	3,	0,	1,	120,	22,	535-30+25,	385+110,  +105,	103,	0,	0
gkRAND,iRN	FLbutton	"Random sliders",	0,	1,	1,	120,	22,	672-30+25,	385+110,  +105,	105,	0,	0
gkbank,i0	FLbutton	"Save project", 	0,	1,	1,	120,	22,	535-30+25,	360+110,  	+105,	107,	0,	0
gkloadP,i01	FLbutton	"Load project", 	0,	1,	1,	120,	22,	672-30+25,	360+110,  	+105,	108,	0,	0
		FLsetBox 4,ihSV
		FLsetBox 4,gihload
		FLsetBox 4,ihRA
		FLsetBox 4,iRN
		FLsetBox 4,i0
		FLsetBox 4,i01
		FLsetTextColor 128,0,0,i0
		FLsetTextColor 128,0,0,i01

gkGet,gihsnap	FLbutBank	3,	8,	2,	259,	40,	505+25,	545,	-105,	110,	0,	0	
		FLsetVal_i	0,gihsnap
		FLsetVal_i	1,gihsnap
		FLsetBox	4,gihsnap

gkMidiPrCH,giPrCh	FLcount		"Program Change", 0, 127, 1,25, 1, 90,25, 140+40,560,+105,5,0,0
		FLsetVal_i 	0,giPrCh	
		FLsetBox	4,giPrCh
		FLsetAlign	2,giPrCh

gkMidiChnl,giChnl	FLcount		"Midi channel", 1, 16, 1,1, 2, 50,25, 245+40,560,+105,5,0,0
		FLsetVal_i 	1,giChnl	
		FLsetBox	4,giChnl
		FLsetAlign 	2,giChnl



gidialog	FLbox	"Really exit now? ",	1,gifont,16,0,0,0,0
gkyes,giyes	FLbutton "YES",	1,	0,	2,	0,	0,	0,0,	-105
		FLsetVal_i 0,giyes
gkno,gino	FLbutton "NO",	1,	0,	2,	0,	0,	0,0,	-105
		FLsetVal_i 0,gino


	FLpanel_end
	FLrun


instr 1
FLshow giPRINTgradi
FLshow giPRINTserie

giNserie	init	giNserie+1

reset:
;_____________ ;TRANSITIONS:(Parameters of Synthesis for every Series)________________

iSplitDown	=	int(i(gk1))	;0	=	Do4 
iSplitUp	=	int(i(gk2)+1)	;23	=	Do6
iOffSet		=	1+(i(gk7) * ((iSplitUp-iSplitDown)-1))	;ctrl7	1,	12,	1,int(iSplitUp)-int(iSplitDown)
idirez		=	i(gkDirez)	;ctrl7	1,	13,	0,1
;_________________________________________________________________________________


iHZtemp		init	98	;function that accommodates the series
iHZfn		init	99	;function that identifies the series expressed in HZ
iHZfonte	init	100	;function that dawns to every series: iHzfn 
icount		init	0 
	
	tableicopy	iHZtemp,iHZfonte

giGradiSerie	=	abs(iSplitUp - iSplitDown)

trigger:
	timout 0, (1/kr)*4,loop
	reinit	trigger

loop:

	if icount	< giGradiSerie	goto jump

	FLprintk 0,giNserie,giPRINTserie
	FLprintk 0,giGradiSerie,giPRINTgradi

	call 99, 0,1/kr
	turnoff

jump:
iMoveAS	=	iSplitDown+icount+iOffSet
iMoveA	=	(iMoveAS < iSplitUp ? iMoveAS : iSplitUp)
indexA	random	iSplitDown, iMoveA			;Ascending envelope
iMoveDi	=	iSplitUp	-	icount	-	iOffSet
iMoveD	=	(iMoveDi > iSplitDown ? iMoveDi : iSplitDown)
indexD	random	iMoveD,iSplitUp			;Descendant envelope
index	=	(idirez > 0.5 ? indexA : indexD)
inote	tab_i int(index),iHZtemp

	tabw_i	0.5,int(index),iHZtemp
	if inote < 1 goto salta
	tabw_i inote,icount,iHZfn

incr	=	(inote < 1 ? 0 : 1)
icount	=	icount + incr

salta:
endin

instr 2
kact active 99
if kact > 0 goto end

ktrig1	changed int(gk1)
	schedk  ktrig1, +105,3,0, 0		;Move textnote up

ktrig2 	changed int(gk2)
	schedk  ktrig2, +105,4,0, 0		;Move textnote up

ktrig3 	changed gkCc0,gkCc1,gkCc2,gkCc3,gkCc4,gkCc5,gkCc6,gkCc7,gkCc8,gkCc9,gkCc10,gkCc11,gkCc12,gkCc13,gkCc14,gkCc15
	schedk  ktrig3, +105,6,0, 0		;Seend midi message

ktrig4 	changed gkMap1,gkMap2
	schedk  ktrig4, +105,7,0, 0		;Seend midi message

end:
endin

instr 3
tb0_init	100	
imove1	init	int(i(gk1)) /($SplitUpMax+1)
	FLsetPosition (imove1*760)+(30*(1-imove1)),15+25,ginoteUp
		FLsetText tb0(int(i(gk1))), ginoteUp
	
	if i(gk1) < i(gk2) igoto salta
		FLsetVal_i i(gk1),ginit2
	salta:
endin
instr 4
tb0_init	100	
imove2	init	int(i(gk2)) /($SplitDownMax+1)
	FLsetPosition (imove2*760)+(30*(1-imove2)),130+30,ginoteDown
		FLsetText tb0(int(i(gk2))), ginoteDown

if i(gk2) > i(gk1) igoto salta
FLsetVal_i i(gk2),ginit1
salta:
endin

instr 5

	outipc	i(gkMidiChnl), i(gkMidiPrCH), 0, 127

endin

instr 6
	outic	i(gkMidiChnl), 0, i(gkCc0), 0,127
	outic	i(gkMidiChnl), 1, i(gkCc1), 0,127
	outic	i(gkMidiChnl), 2, i(gkCc2), 0,127
	outic	i(gkMidiChnl), 3, i(gkCc3), 0,127
	outic	i(gkMidiChnl), 4, i(gkCc4), 0,127
	outic	i(gkMidiChnl), 5, i(gkCc5), 0,127
	outic	i(gkMidiChnl), 6, i(gkCc6), 0,127
	outic	i(gkMidiChnl), 7, i(gkCc7), 0,127
	outic	i(gkMidiChnl), 8, i(gkCc8), 0,127
	outic	i(gkMidiChnl), 9, i(gkCc9), 0,127
	outic	i(gkMidiChnl), 10, i(gkCc10), 0,127
	outic	i(gkMidiChnl), 11, i(gkCc11), 0,127
	outic	i(gkMidiChnl), 12, i(gkCc12), 0,127
	outic	i(gkMidiChnl), 13, i(gkCc13), 0,127
	outic	i(gkMidiChnl), 14, i(gkCc14), 0,127
	outic	i(gkMidiChnl), 15, i(gkCc15), 0,127

endin

instr 7
FLsetVal_i i(gkMap1),gihD1
FLsetVal_i i(gkMap2),gihD2
call 8, 0,4/kr,i(gkSb),i(gkD1),i(gkD2)		
endin

instr 8
midiout	p4,  i(gkMidiChnl), p5, p6
turnoff
endin


instr 9
incr1	init	-1
reset:
incr1	=	incr1 + 1

midiout	176+incr1,  1, 121, 0	;reset all
midiout	176+incr1,  2, 121, 0
midiout	176+incr1,  3, 121, 0
midiout	176+incr1,  4, 121, 0
midiout	176+incr1,  5, 121, 0
midiout	176+incr1,  6, 121, 0
midiout	176+incr1,  7, 121, 0
midiout	176+incr1,  8, 121, 0
midiout	176+incr1,  9, 121, 0
midiout	176+incr1,  10, 121, 0
midiout	176+incr1,  11, 121, 0
midiout	176+incr1,  12, 121, 0
midiout	176+incr1,  13, 121, 0
midiout	176+incr1,  14, 121, 0
midiout	176+incr1,  15, 121, 0
midiout	176+incr1,  16, 121, 0

midiout	176+incr1,  1, 123, 0	;panic
midiout	176+incr1,  2, 123, 0
midiout	176+incr1,  3, 123, 0
midiout	176+incr1,  4, 123, 0
midiout	176+incr1,  5, 123, 0
midiout	176+incr1,  6, 123, 0
midiout	176+incr1,  7, 123, 0
midiout	176+incr1,  8, 123, 0
midiout	176+incr1,  9, 123, 0
midiout	176+incr1,  10, 123, 0
midiout	176+incr1,  11, 123, 0
midiout	176+incr1,  12, 123, 0
midiout	176+incr1,  13, 123, 0
midiout	176+incr1,  14, 123, 0
midiout	176+incr1,  15, 123, 0
midiout	176+incr1,  16, 123, 0

if incr1 = 15 goto end

timout 0,10/kr, contin
reinit reset
end:
turnoff
contin:

endin

instr 10
FLsetVal_i 144,gihSb
endin

instr 99	;Caller Instrument

;_____________ ;TRANSITIONS:(Parameters of Synthesis for every Series)________________
itemp		init	i(gk1)
iDensINIT	init	1 / i(gk3)		
iDensFINAL	init	1 / i(gk4)	
iDurINIT	init	i(gk5)	
iDurFINAL	init	i(gk6)	
iAmpIni		init	i(gk8)	
iAmpFin		init	i(gk9)	
iAccent		init	i(gk10)	
itype1		init	i(gkurva1)
itype2		init	i(gkurva2)
itype3		init	i(gkurva3)

index		init	-1
;_____________________________________________________________________________________

icurva1		ftgen 	50,    0,	128,    -16,    iDensINIT,  giGradiSerie,  itype1,  iDensFINAL
icurva2		ftgen 	51,    0,	128,    -16,    iDurINIT,  giGradiSerie,  itype2,  iDurFINAL
icurva3		ftgen 	52,    0,	128,    -16,    iAmpIni,  giGradiSerie,  itype3,  iAmpFin

reset:

index 	=		index	+	1

ifreq	tab_i	index,99
icall	tab_i	index,icurva1
idur	tab_i	index,icurva2
iAmp	tab_i	index,icurva3


;icall	ntrpol	iDensINIT, iDensFINAL, index, 0, giGradiSerie
;idur	ntrpol	iDurINIT, iDurFINAL, index, 0, giGradiSerie
;iAmp	ntrpol	iAmpIni,iAmpFin,index, 0, giGradiSerie
iAcc 	= 	int(iAmp + birnd(iAmp*iAccent))

FLsetVal 1, ifreq-20,ginit1
	FLsetText ifreq-21, ginoteUp	

		if index < giGradiSerie-1 goto salta

	FLsetVal 1,itemp,ginit1
FLsetText itemp+21, ginoteUp

	turnoff
salta:
	timout 0, icall,contin
	reinit reset

contin:
	calld 100,1/kr,1/kr,ifreq,iAcc,idur
endin

instr 100	;Remote instrument MIDI calls one

	noteondur	1,	p4,	 p5,	p6
endin

instr 101	;Store snapshots into disk

tabw_i int(i(gk1)),0,i(gkGet)+gisnap0
tabw_i int(i(gk2)),1,i(gkGet)+gisnap0
tabw_i i(gk3),2,i(gkGet)+gisnap0
tabw_i i(gk4),3,i(gkGet)+gisnap0
tabw_i i(gk5),4,i(gkGet)+gisnap0
tabw_i i(gk6),5,i(gkGet)+gisnap0
tabw_i i(gk7),6,i(gkGet)+gisnap0
tabw_i i(gk8),7,i(gkGet)+gisnap0
tabw_i i(gk9),8,i(gkGet)+gisnap0
tabw_i i(gk10),9,i(gkGet)+gisnap0
tabw_i i(gkurva1),10,i(gkGet)+gisnap0
tabw_i i(gkurva2),11,i(gkGet)+gisnap0
tabw_i i(gkurva3),12,i(gkGet)+gisnap0


endin

instr 102	;Load snapshots 

ik1	tab 0,i(gkGet)+gisnap0
ik2	tab 1,i(gkGet)+gisnap0
ik3	tab 2,i(gkGet)+gisnap0
ik4	tab 3,i(gkGet)+gisnap0
ik5	tab 4,i(gkGet)+gisnap0
ik6	tab 5,i(gkGet)+gisnap0
ik7	tab 6,i(gkGet)+gisnap0
ik8	tab 7,i(gkGet)+gisnap0
ik9	tab 8,i(gkGet)+gisnap0
ik10	tab 9,i(gkGet)+gisnap0
ik11	tab 10,i(gkGet)+gisnap0
ik12	tab 11,i(gkGet)+gisnap0
ik13	tab 12,i(gkGet)+gisnap0

	FLsetVal_i	ik1,ginit1
	FLsetVal_i	ik2,ginit2
	FLsetVal_i	ik3,ginit3
	FLsetVal_i	ik4,ginit4
	FLsetVal_i	ik5,ginit5
	FLsetVal_i	ik6,ginit6
	FLsetVal_i	ik7,ginit7
	FLsetVal_i	ik8,ginit8
	FLsetVal_i	ik9,ginit9
	FLsetVal_i	ik10,ginit10
	FLsetVal_i	ik11,gicurva1
	FLsetVal_i	ik12,gicurva2
	FLsetVal_i	ik13,gicurva3

endin


instr 103	;Reset default values

FLsetVal_i $SplitDownDef,	ginit1	
FLsetVal_i $SplitUpDef,		ginit2
FLsetVal_i $NumberEventsBegDef,	ginit3
FLsetVal_i $NumberEventsEndDef,	ginit4
FLsetVal_i $DurationEventsBegDef,ginit5
FLsetVal_i $DurationEventsEndDef,ginit6
FLsetVal_i $WidthSerieDef,	ginit7
FLsetVal_i $AmpEventsBegDef,	ginit8
FLsetVal_i $AmpEventsEndDef,	ginit9
FLsetVal_i $AccentSerieDef,	ginit10
FLsetVal_i $Curva_1Def,		gicurva1
FLsetVal_i $Curva_2Def,		gicurva2
FLsetVal_i $Curva_3Def,		gicurva3
FLsetVal_i 0,		giPrCh
FLsetVal_i 1,		giChnl
endin

instr 105


iR1	random	$SplitDownMin,		$SplitDownMax
iR2	random	iR1,			$SplitUpMax
iR3	random	$NumberEventsBegMin,	$NumberEventsBegMax
iR4	random	$NumberEventsEndMin,	$NumberEventsEndMax
iR5	random	$DurationEventsBegMin,	$DurationEventsBegMax
iR6	random	$DurationEventsEndMin,	$DurationEventsEndMax
iR8	random	$AmpEventsBegMin,	$AmpEventsBegMax
iR9	random	$AmpEventsEndMin,	$AmpEventsEndMax
iR7	random	$WidthSerieMin,		$WidthSerieMax
iR10	random	$AccentSerieMin,	$AccentSerieMax
iR11	random	$Curva_1Min,		$Curva_1Max
iR12	random	$Curva_2Min,		$Curva_2Max
iR13	random	$Curva_3Min,		$Curva_3Max
iR14	random	0,			127

	FLsetVal_i	iR1,ginit1
	FLsetVal_i	iR2,ginit2
	FLsetVal_i	iR3,ginit3
	FLsetVal_i	iR4,ginit4
	FLsetVal_i	iR5,ginit5
	FLsetVal_i	iR6,ginit6
	FLsetVal_i	iR7,ginit7
	FLsetVal_i	iR8 ,ginit8
	FLsetVal_i	iR9 ,ginit9
	FLsetVal_i	iR10 ,ginit10
	FLsetVal_i	iR11,gicurva1
	FLsetVal_i	iR12,gicurva2
	FLsetVal_i	iR13,gicurva3

FLsetVal_i	iR14,giPrCh
endin

instr 107 ;Save Bank to disk

	ftsave	$PROJECT, 1, gisnap0,gisnap1,gisnap2,gisnap3,gisnap4,gisnap5,gisnap6,gisnap7,gisnap8,gisnap9,gisnap10,gisnap11,gisnap12,gisnap13,gisnap14,gisnap15

endin

instr 108 ;Load project

	ftload	$PROJECT, 1, gisnap0,gisnap1,gisnap2,gisnap3,gisnap4,gisnap5,gisnap6,gisnap7,gisnap8,gisnap9,gisnap10,gisnap11,gisnap12,gisnap13,gisnap14,gisnap15

endin


instr 110	;Exitnow
FLshow gidialog
FLshow giyes
FLshow gino
FLsetVal_i 0, giyes
FLsetVal_i 0, gino
FLsetTextSize 19,gidialog
FLsetTextColor 200,0,0,gidialog
FLsetAlign 6,gidialog
FLsetBox 9, gidialog 
FLsetBox 8, giyes
FLsetBox 8, gino
cambia:
FLsetText "Really exit now?",gidialog
FLsetPosition	250,250,gidialog
FLsetSize 250,100,gidialog
FLsetPosition	280,290,giyes
FLsetSize 50,25,giyes
FLsetPosition	420,290,gino
FLsetSize 50,25,gino
if i(gkyes) = 1 igoto exit
if i(gkno) = 1 igoto show
timout 0,1/12, end
reinit cambia
igoto end
show:
FLhide gidialog
FLhide giyes
FLhide gino
turnoffk gkno
igoto end
exit:
exitnow
end:
endin

</CsInstruments>
<CsScore>
f98	0	512	-2	0
f99	0	512	-2	0
f100 	0	512	-2 	21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 

f0	[3600*3]	;Max performance time
i2 0	[3600*3]	;Max performance time
i10 .1 	0
e

</CsScore>
</CsoundSynthesizer>
